// flex-decoder.js

module.exports = FlexDecoder;

var FlexBuffer = require("./flex-buffer");
var utils = require("./flex-utils");

function FlexDecoder() {
  if (!(this instanceof FlexDecoder)) return new FlexDecoder();
}

var methods = FlexBuffer.mixin({});
methods.write = write;

var mixin = FlexDecoder.mixin = utils.createMixin(methods);
mixin(FlexDecoder.prototype);

function write(chunk) {
  var prev = this.offset ? this.buffer.slice(this.offset) : this.buffer;
  this.buffer = prev ? (chunk ? Buffer.concat([prev, chunk]) : prev) : chunk;
  this.offset = 0;
}
